﻿ r←test_coolStat nul;vec;x;c;ref
 :If 2 Check #.coolStat.Median 1 2 32768
     →0 Because'Median did not return 2' ⋄ :EndIf
 :If 2 Check #.coolStat.Avg 1 2 3
     →0 Because'Avg failed dramatically!' ⋄ :EndIf

 vec←'input'##.RandomVal 10000000,'length'##.RandomVal 500001               ⍝ random input = ⍵[2]?⍵[1]
 x←(+/vec)÷≢vec                       ⍝ calculating reference value using trusted algorithms
 :If x Check #.coolStat.Avg vec       ⍝ and compare refval against new calculation
     →0 Because'Avg did not return expected result' ⋄ →0 ⋄ :EndIf

 vec←vec[⍋vec]
 :If x Check #.coolStat.Avg vec
     →0 Because'Avg had a difference with sorted/unsorted vec' ⋄ :EndIf
 x Assert #.coolStat.Avg vec          ⍝ sorting should not affect calculation
 c←(⌈,⌊)0.5×1+≢vec                    ⍝ determine location of center value(s)
 ref←#.coolStat.Avg vec[c]            ⍝ refval is (average of) center value(s)
 :If ref Check #.coolStat.Median vec
     →0 Because'Median did not return exepected result' ⋄ :EndIf

 r←''                                 ⍝ empty result: tests ok!
